/**
 * Copyright (C) 2014 Justin James.
 *
 * This license must be preserved.
 * Any applications, libraries, or code which make any use of any
 * component of this program must not be commercial, unless explicit
 * permission is granted from the original author. The use of this
 * program for non-profit purposes is permitted.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * In the event that this license restricts you from making desired use of this program, contact the original author.
 * Written by Justin James <justin.aj@hotmail.com>
 */

#include <cstring>
#include "FunCommands.h"
#include "IRC_Bot.h"
#include "Functions.h"
#include "Socket.h"

// 8ball

void EightBallIRCCommand::create()
{
	this->addTrigger("8ball");
	this->addTrigger("8balls");
	this->addTrigger("eightBall");
}

void EightBallIRCCommand::trigger(IRC_Bot *source, const Jupiter::CStringType &channel, const Jupiter::CStringType &nick, const Jupiter::CStringS &parameters)
{
	char msg[128];
	unsigned short r = rand() % 20;
	switch (r)
	{
	case 0:
		strcpy(msg, "No.");
		break;
	case 1:
		strcpy(msg, "Yes.");
		break;
	case 2:
		strcpy(msg, "Maybe.");
		break;
	case 3:
		strcpy(msg, "Seven.");
		break;
	case 4:
		strcpy(msg, "Consider counseling.");
		break;
	case 5:
		strcpy(msg, "Look into a realationship. A real one.");
		break;
	case 6:
		strcpy(msg, "Quit asking me these deep questions, before I get deeply into you.");
		break;
	case 7:
		strcpy(msg, "Fuck you.");
		break;
	case 8:
		strcpy(msg, "Fuck me.");
		break;
	case 9:
		strcpy(msg, "I'm sorry, I don't bend that way.");
		break;
	case 10:
		sprintf(msg, "Hai %s ;)", nick.c_str());
		break;
	case 11:
		sprintf(msg, "Let's ban %s!", nick.c_str());
		break;
	case 12:
		sprintf(msg, "Sorry %s, but your IQ must be at least %d for me to care.", nick.c_str(), rand() % 50);
		break;
	case 13:
		strcpy(msg, "Ask me those kind of questions in #Faggots");
		break;
	case 14:
		strcpy(msg, "I don't talk to slut-mongers.");
		break;
	case 15:
		strcpy(msg, "I only talk to slut-mongers.");
		break;
	case 16:
		strcpy(msg, "Nuclear launch detected.");
		break;
	case 17:
		strcpy(msg, "404 - Not found.");
		break;
	case 18:
		strcpy(msg, "I hurr u liek mudkipz?");
		break;
	case 19:
		strcpy(msg, "Walk this way, babycakes ;)");
		break;
	default:
		strcpy(msg, "Nothingness. You suck. Go rot.");
		break;
	}
	source->sendMessage(channel.c_str(), msg);
}

const char *EightBallIRCCommand::getHelp()
{
	return "Syntax: 8ball [question]";
}

IRC_COMMAND_INIT(EightBallIRCCommand)

// Resolve Command

void ResolveIRCCommand::create()
{
	this->addTrigger("resolve");
}

void ResolveIRCCommand::trigger(IRC_Bot *source, const Jupiter::CStringType &channel, const Jupiter::CStringType &nick, const Jupiter::CStringS &parameters)
{
	if (parameters != nullptr)
	{
		int wCount = parameters.wordCount(WHITESPACE);
		if (wCount >= 2)
		{
			Jupiter::CStringS w1 = parameters.getWord(0, WHITESPACE);
			Jupiter::CStringS w2 = parameters.getWord(1, WHITESPACE);
			if (w1.equalsi("hostname") || w1.equalsi("host"))
			{
				char *resolved = Jupiter::Socket::resolveHostname(w2.c_str(), 0);
				if (resolved != nullptr)
				{
					source->sendMessage(channel.c_str(), resolved);
					delete[] resolved;
				}
				else source->sendMessage(channel.c_str(), "Error: Unable to resolve.");
			}
			else if (w1.equalsi("ip"))
			{
				char *resolved = Jupiter::Socket::resolveAddress(w2.c_str(), 0);
				if (resolved != nullptr)
				{
					source->sendMessage(channel.c_str(), resolved);
					delete[] resolved;
				}
				else source->sendMessage(channel.c_str(), "Error: Unable to resolve.");
			}
			else source->sendNotice(nick.c_str(), "Error: Invalid type. You can only resolve hostnames and IP addresses.");
		}
		else source->sendNotice(nick.c_str(), "Too few parameters. Syntax: resolve <hostname|ip> <address>");
	}
	else source->sendNotice(nick.c_str(), "Too few parameters. Syntax: resolve <hostname|ip> <address>");
}

const char *ResolveIRCCommand::getHelp()
{
	return "Syntax: resolve <hostname|ip> <address>";
}

IRC_COMMAND_INIT(ResolveIRCCommand)

// Plugin instantiation and entry point.
ExtraCommandsPlugin pluginInstance;

extern "C" __declspec(dllexport) Jupiter::Plugin *getPlugin()
{
	return &pluginInstance;
}
