/**
 * This file is in the public domain, furnished "as is", without technical
 * support, and with no warranty, express or implied, as to its usefulness for
 * any purpose.
 *
 * Written by Justin James <justin.aj@hotmail.com>
 */

#include "Example.h"
#include "IRC_Bot.h"

void ExamplePlugin::OnConnect(Jupiter::IRC::Client *server)
{
	server->sendNotice("Agent", "Honey, I'm home!");
}

// Example IRC Command Implementation

void ExampleIRCCommand::create()
{
	this->addTrigger("example");
}

void ExampleIRCCommand::trigger(IRC_Bot *source, const Jupiter::CStringType &channel, const Jupiter::CStringType &nick, const Jupiter::CStringS &parameters)
{
	source->sendMessage(channel.c_str(), "This is an example command!");
}

const char *ExampleIRCCommand::getHelp()
{
	return "This is just an example command. It takes no parameters!";
}

IRC_COMMAND_INIT(ExampleIRCCommand)


// Plugin instantiation and entry point.
ExamplePlugin pluginInstance;

extern "C" __declspec(dllexport) Jupiter::Plugin *getPlugin()
{
	return &pluginInstance;
}
