/**
 * Copyright (C) 2014 Justin James.
 *
 * This license must be preserved.
 * Any applications, libraries, or code which make any use of any
 * component of this program must not be commercial, unless explicit
 * permission is granted from the original author. The use of this
 * program for non-profit purposes is permitted.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * In the event that this license restricts you from making desired use of this program, contact the original author.
 * Written by Justin James <justin.aj@hotmail.com>
 */

#if !defined _RENX_LOGGING_H_HEADER
#define _RENX_LOGGING_H_HEADER

#include "Plugin.h"
#include "RenX_Plugin.h"

class RenX_LoggingPlugin : public RenX::Plugin
{
public: // RenX::Plugin
	void RenX_OnJoin(RenX::Server *server, const RenX::PlayerInfo *player);
	void RenX_OnPart(RenX::Server *server, const RenX::PlayerInfo *player);
	void RenX_OnNameChange(RenX::Server *server, const RenX::PlayerInfo *player, const Jupiter::CStringS &newPlayerName);
	
	void RenX_OnChat(RenX::Server *server, const RenX::PlayerInfo *player, const Jupiter::CStringS &message);
	void RenX_OnTeamChat(RenX::Server *server, const RenX::PlayerInfo *player, const Jupiter::CStringS &message);
	
	void RenX_OnDeploy(RenX::Server *server, const RenX::PlayerInfo *player, const Jupiter::CStringS &object);
	void RenX_OnSuicide(RenX::Server *server, const RenX::PlayerInfo *player, const Jupiter::CStringS &damageType);
	void RenX_OnKill(RenX::Server *server, const RenX::PlayerInfo *player, const RenX::PlayerInfo *victim, const Jupiter::CStringS &damageType);
	void RenX_OnDie(RenX::Server *server, const RenX::PlayerInfo *player, const Jupiter::CStringS &damageType);
	void RenX_OnDestroy(RenX::Server *server, const RenX::PlayerInfo *player, const Jupiter::CStringS &objectName, const Jupiter::CStringS &damageType, RenX::ObjectType type);
	void RenX_OnGameOver(RenX::Server *server, RenX::WinType winType, RenX::TeamType team, int gScore, int nScore);
	void RenX_OnGame(RenX::Server *server, const Jupiter::CStringS &raw);
	
	void RenX_OnExecute(RenX::Server *server, const Jupiter::CStringS &user, const Jupiter::CStringS &command);
	void RenX_OnSubscribe(RenX::Server *server, const Jupiter::CStringS &user);
	void RenX_OnRCON(RenX::Server *server, const Jupiter::CStringS &raw);
	
	void RenX_OnAdminLogin(RenX::Server *server, const RenX::PlayerInfo *player);
	void RenX_OnAdminLogout(RenX::Server *server, const RenX::PlayerInfo *player);
	void RenX_OnAdmin(RenX::Server *server, const Jupiter::CStringS &raw);

	void RenX_OnLog(RenX::Server *server, const Jupiter::CStringS &raw);
	void RenX_OnCommand(RenX::Server *server, const Jupiter::CStringS &raw);
	void RenX_OnError(RenX::Server *server, const Jupiter::CStringS &raw);
	void RenX_OnVersion(RenX::Server *server, const Jupiter::CStringS &raw);
	void RenX_OnAuthorized(RenX::Server *server, const Jupiter::CStringS &raw);
	void RenX_OnOther(RenX::Server *server, const char token, const Jupiter::CStringS &raw);

public: // Plugin
	const char *getName() { return "RenX.Logging"; }
};

#endif // _RENX_LOGGING_H_HEADER